From 2558c740b756e31a5e20ad797131402e8683ac23 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 22:52:41 +0000
Subject: [PATCH 1292/2232] Ensure error messages remain in sync with CFG


---

diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
index 877a973..260116f 100644
--- a/gen/build/src/error.rs
+++ b/gen/build/src/error.rs
@@ -1,3 +1,4 @@
+use crate::cfg::CFG;
 use crate::gen::fs;
 use std::error::Error as StdError;
 use std::ffi::OsString;
@@ -14,6 +15,13 @@ pub(super) enum Error {
     ExportedEmptyPrefix,
 }
 
+macro_rules! expr {
+    ($expr:expr) => {{
+        let _ = $expr; // ensure it doesn't fall out of sync with CFG definition
+        stringify!($expr)
+    }};
+}
+
 impl Display for Error {
     fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
         match self {
@@ -23,12 +31,15 @@ impl Display for Error {
             Error::Fs(err) => err.fmt(f),
             Error::ExportedDirNotAbsolute(path) => write!(
                 f,
-                "element of CFG.exported_header_dirs must be absolute path, but was: {:?}",
+                "element of {} must be absolute path, but was: {:?}",
+                expr!(CFG.exported_header_dirs),
                 path,
             ),
-            Error::ExportedEmptyPrefix => {
-                f.write_str("element of CFG.exported_header_prefixes must not be empty string")
-            }
+            Error::ExportedEmptyPrefix => write!(
+                f,
+                "element of {} must not be empty string",
+                expr!(CFG.exported_header_prefixes),
+            ),
         }
     }
 }

